require 'spec_helper'

describe TimeKeeper::TimeRangeCollection do
  subject do
    TimeKeeper::TimeRangeCollection.new("06:00 pm - 03:00 am\n07:00 - 17:00")
  end

  describe "#initialize" do
    it "should set the time_ranges_str variable" do
      TimeKeeper::TimeRangeCollection.new("06:00 pm - 03:00 am\n07:00 - 17:00").instance_variable_get('@time_ranges_str').should eq("06:00 pm-03:00 am\n07:00-17:00")
    end
  end

  describe "#parse" do
    it "should match return proper range sets count" do
      subject.parse
      subject.instance_variable_get("@time_ranges").count.should eq(2)
    end

    it "should set the time ranges properly" do
      subject.parse
      subject.time_ranges.first.start_time.in_minutes.should eq(1080)
      subject.time_ranges.first.end_time.in_minutes.should eq(180)
      subject.time_ranges.first.start_day.should eq(0)
      subject.time_ranges.first.end_day.should eq(1)
      subject.time_ranges.last.start_time.in_minutes.should eq(420)
      subject.time_ranges.last.end_time.in_minutes.should eq(1020)
      subject.time_ranges.last.start_day.should eq(1)
      subject.time_ranges.last.end_day.should eq(1)
    end

    it "should return the time ranges collection object" do
      subject.parse.should eq(subject)
    end
  end
end